unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, Dxcore,
  activex;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_SxXnKcList, U_OrderProgress, U_AllOrderProgress, U_CPTopList,
  U_KHTopList, U_OrderLRList, U_OrderProgress2, U_DDLRCX, U_YWYTopList;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////
var
  frmOrderProgress2GL, frmOrderProgress2L: TfrmOrderProgress2;
  frmDDLRCXGL, frmDDLRCXL: TfrmDDLRCX;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  mnewHandle: hwnd;
  bFound: Boolean;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  server := '121.40.233.100,7781';
//  server := '.';
  dtbase := 'TUOXUAN10data';
  user := 'sa';
  pswd := 'rightsoft@123';
//  pswd := 'rightsoft';
  DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
  DConString := DataBaseStr;
  // DName:='周高祥';
   //DParameters1:='高权限';   //高权限
   //DParameters3:='1';
  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    111:  //订单进度查询
      begin
        if frmOrderProgress = nil then
        begin
          frmOrderProgress := TfrmOrderProgress.Create(application.MainForm);
          with frmOrderProgress do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmOrderProgress.BringToFront;
       //句柄
        mnewHandle := frmOrderProgress.Handle;
      end;

    112:  //订单进度管理
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '订单利润管理' then
          begin
            BringWindowToTop(frmOrderProgress2GL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmOrderProgress2GL := TfrmOrderProgress2.Create(application.MainForm);
          with frmOrderProgress2GL do
          begin
            Title := '订单利润管理';
            CANSHU1 := '管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmOrderProgress2GL.BringToFront;
       //句柄
        mnewHandle := frmOrderProgress2GL.Handle;
      end;

    113:  //订单进度查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '订单利润查询' then
          begin
            BringWindowToTop(frmOrderProgress2L.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmOrderProgress2L := TfrmOrderProgress2.Create(application.MainForm);
          with frmOrderProgress2L do
          begin
            Title := '订单利润查询';
            CANSHU1 := '查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmOrderProgress2L.BringToFront;
       //句柄
        mnewHandle := frmOrderProgress2L.Handle;
      end;

    121:  //订单利润查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '成本毛利核算' then
          begin
            BringWindowToTop(frmDDLRCXGL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmDDLRCXGL := TfrmDDLRCX.Create(application.MainForm);
          with frmDDLRCXGL do
          begin
            Title := '成本毛利核算';
            canshu1 := '管理';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmDDLRCXGL.BringToFront;
       //句柄
        mnewHandle := frmDDLRCXGL.Handle;
      end;
    122:  //订单利润查询
      begin
        bFound := FALSE;
        for i := (App.MainForm.MDIChildCount - 1) downto 0 do
        begin
          if App.MainForm.MDIChildren[i].Caption = '成本毛利核算(业务员)' then
          begin
            BringWindowToTop(frmDDLRCXL.Handle);
            bFound := TRUE;
            Break;
          end;
        end;
        if not bFound then
        begin
          frmDDLRCXL := TfrmDDLRCX.Create(application.MainForm);
          with frmDDLRCXL do
          begin
            Title := '成本毛利核算(业务员)';
            canshu1 := '查询';
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmDDLRCXL.BringToFront;
       //句柄
        mnewHandle := frmDDLRCXL.Handle;
      end;
    131:  //客户销量排行榜
      begin
        if frmKHTopList = nil then
        begin
          frmKHTopList := TfrmKHTopList.Create(application.MainForm);
          with frmKHTopList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmKHTopList.BringToFront;
       //句柄
        mnewHandle := frmKHTopList.Handle;
      end;
    132:  //产品销量排行榜
      begin
        if frmCPTopList = nil then
        begin
          frmCPTopList := TfrmCPTopList.Create(application.MainForm);
          with frmCPTopList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPTopList.BringToFront;
       //句柄
        mnewHandle := frmCPTopList.Handle;
      end;
    133:  //业务员销量排行榜
      begin
        if frmywyTopList = nil then
        begin
          frmYWYTopList := TfrmYWYTopList.Create(application.MainForm);
          with frmYWYTopList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmYWYTopList.BringToFront;
       //句柄
        mnewHandle := frmYWYTopList.Handle;
      end;
  end;

  Result := mnewHandle;
//  NewDllApp := Application;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
begin
  if not Assigned(DataLink_Statistics) then
    DataLink_Statistics := TDataLink_Statistics.Create(Application);
  try
    with DataLink_Statistics.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

//initialization
//  OldDllApp := Application;
//
//finalization
//  DataLink_Statistics.Free;
//  Application := OldDllApp;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_Statistics.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

